// SimpleMp3Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleMp3.h"
#include "SimpleMp3Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSimpleMp3Dlg dialog




CSimpleMp3Dlg::CSimpleMp3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleMp3Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_Stream = NULL;
	m_nVolume = 200;
	m_nChannel = -1;
	m_nMpNum = 0;
	m_nNowMp = 0;
	m_Status = S_STOP;
	m_strMpName = "";
}

void CSimpleMp3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER1, m_ctrlSlider);
	DDX_Control(pDX, IDC_LIST1, m_ctrlList);
}

BEGIN_MESSAGE_MAP(CSimpleMp3Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_PLAY, &CSimpleMp3Dlg::OnBnClickedPlay)
	ON_BN_CLICKED(IDC_STOP, &CSimpleMp3Dlg::OnBnClickedStop)
	ON_WM_VSCROLL()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, &CSimpleMp3Dlg::OnLvnItemchangedList1)
END_MESSAGE_MAP()


// CSimpleMp3Dlg message handlers

BOOL CSimpleMp3Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    HANDLE h;
	h = ::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PLAY), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE|LR_SHARED);
    CButton* pBitmapButtonPlay = (CButton*)GetDlgItem(IDC_PLAY);
    if(h && pBitmapButtonPlay)
        pBitmapButtonPlay->SetBitmap((HBITMAP)h);

    h = ::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_STOP), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE|LR_SHARED);
    CButton* pBitmapButtonStop = (CButton*)GetDlgItem(IDC_STOP);
    if(h && pBitmapButtonStop)
        pBitmapButtonStop->SetBitmap((HBITMAP)h);

	// slider control
	m_ctrlSlider.SetRange(0, 255, FALSE);
	m_ctrlSlider.SetPos(200);
	m_ctrlSlider.SetLineSize(1);	// keyboard Up/Down key
	m_ctrlSlider.SetPageSize(10);	// keyboard PgUp/PgDown key

	// listview control
	m_ctrlList.InsertColumn(0, _T("No."), LVCFMT_LEFT, 30);
	m_ctrlList.InsertColumn(1, _T("̸"), LVCFMT_LEFT, 150);
	m_ctrlList.InsertColumn(2, _T("ǰ"), LVCFMT_LEFT, 150);
	m_ctrlList.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	CString s;
	s.Format("%d", m_nMpNum + 1);
	m_ctrlList.InsertItem(m_nMpNum, s);
	m_ctrlList.SetItemText(m_nMpNum, 1, "Ҹ.mp3");
	m_ctrlList.SetItemText(m_nMpNum, 2, "̽ö");
	m_nMpNum++;

	s.Format("%d", m_nMpNum + 1);
	m_ctrlList.InsertItem(m_nMpNum, s);
	m_ctrlList.SetItemText(m_nMpNum, 1, "Ͼ.mp3");
	m_ctrlList.SetItemText(m_nMpNum, 2, "̽ö");
	m_nMpNum++;

	s.Format("%d", m_nMpNum + 1);
	m_ctrlList.InsertItem(m_nMpNum, s);
	m_ctrlList.SetItemText(m_nMpNum, 1, "Ϸ.mp3");
	m_ctrlList.SetItemText(m_nMpNum, 2, "̽ö");
	m_nMpNum++;

	// image list
	CImageList m_il;
	m_il.Create(16, 16, ILC_COLOR32, 1, 1);
	m_il.Add(AfxGetApp()->LoadIconA(IDI_ICON1));
	m_il.Add(AfxGetApp()->LoadIconA(IDI_ICON2));
	m_il.Add(AfxGetApp()->LoadIconA(IDI_ICON3));
	m_ctrlList.SetImageList(&m_il, LVSIL_SMALL);
	m_il.Detach();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSimpleMp3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimpleMp3Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimpleMp3Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSimpleMp3Dlg::Play()
{
	static BOOL bFirst=TRUE;

	//if (m_nMpNum == 0) {
	//	return;
	//}

	if (bFirst) {
		FSOUND_Init(44100,32,0);
		FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(),TRUE);
		bFirst=FALSE;
	}

	Stop();

	//m_strMpName = "bird.mp3";
	TRACE("PLAY::m_strMpName=%s\n", m_strMpName);

	m_Stream = FSOUND_Stream_Open(m_strMpName, FSOUND_NORMAL, 0, 0);
	if (m_Stream != NULL) {
		m_nChannel = FSOUND_Stream_Play(FSOUND_FREE, m_Stream);
		FSOUND_SetVolume(m_nChannel, m_nVolume);

		m_Status = S_PLAY;

	} else {
		char Mes[512];
		sprintf(Mes,"%s    ϴ.", m_strMpName);
		AfxMessageBox((LPCTSTR)Mes);
	}
}

void CSimpleMp3Dlg::Pause(BOOL flag)
{
	FSOUND_SetPaused(m_nChannel, flag);
}

void CSimpleMp3Dlg::Stop()
{
	if (m_Stream) {
		if (m_Status != S_PLAYAGAIN) 
			m_strMpName = "";
		FSOUND_Stream_Stop(m_Stream);
		FSOUND_Stream_Close(m_Stream);
		m_Stream = NULL;
		m_Status = S_STOP;
	}
}

void CSimpleMp3Dlg::Volume(int vol)
{
	FSOUND_SetVolume(m_nChannel, vol);
}

void CSimpleMp3Dlg::OnBnClickedPlay()
{
	// TODO: Add your control notification handler code here
	TRACE("button played\n");
	if (m_Status == S_STOP)
		Play();
}

void CSimpleMp3Dlg::OnBnClickedStop()
{
	// TODO: Add your control notification handler code here
	TRACE("button stop\n");
	Stop();
}

void CSimpleMp3Dlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default

	if (pScrollBar == (CScrollBar*) &m_ctrlSlider) {
		m_nVolume = m_ctrlSlider.GetPos();
		TRACE("HScroll:: volume: %d\n", m_nVolume);
		Volume(m_nVolume);
	}
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CSimpleMp3Dlg::OnLvnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: Add your control notification handler code here

	if(pNMLV->uChanged & LVIF_STATE) {
		if(pNMLV->uNewState & (LVIS_SELECTED|LVIS_FOCUSED)) {
			m_strMpName = m_ctrlList.GetItemText(pNMLV->iItem, 1);
			m_Status = S_PLAYAGAIN;
			Play();
		}
	}
	*pResult = 0;
}
