// SimpleMp3Dlg.h : header file
//

#pragma once
#include "fmod.h"
#include "afxcmn.h"
#include "afxwin.h"


// CSimpleMp3Dlg dialog
class CSimpleMp3Dlg : public CDialog
{
// Construction
public:
	CSimpleMp3Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_SIMPLEMP3_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	FSOUND_STREAM * m_Stream;
	enum tag_Status { S_STOP, S_PAUSE, S_PLAY, S_PLAYAGAIN } m_Status;
	int m_nVolume;
	int m_nChannel;
	int m_nMpNum;
	int m_nNowMp;
	CString m_strMpName;

	void Play();
	void Pause(BOOL);
	void Stop();
	void Volume(int);

	afx_msg void OnBnClickedPlay();
	afx_msg void OnBnClickedStop();

	CSliderCtrl m_ctrlSlider;
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	CListCtrl m_ctrlList;
	afx_msg void OnLvnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult);
};
